DECLARE SUB EpsInitialize ()
DECLARE SUB EpsDefineElements ()
DECLARE SUB EpsDrawScreen ()
DECLARE SUB EpsDrawWindow (Number%)
DECLARE SUB EpsDrawLabel (Number%)
DECLARE SUB EpsDrawTextBox (Number%)
DECLARE SUB EpsDrawButton (Number%)
DECLARE SUB EpsMainLoop ()
DECLARE SUB EpsDrawTextField (Number%)
DECLARE FUNCTION CommonDialogBox$ ()
'$INCLUDE: 'future.bi'
'$INCLUDE: 'eps-gui.bi'

ON ERROR GOTO Fail

EpsInitialize
EpsDefineElements
EpsDrawScreen

FileName$ = CommonDialogBox$

Future.MouseOff
ReSetScreen

PRINT FileName$

END

'ͻ
' Fehlerverfolgung                                                       
'ͼ
Fail:
	Fail = ERR
RESUME NEXT

REM $DYNAMIC
DEFSNG A-Z
FUNCTION CommonDialogBox$
'$DYNAMIC
DEFINT A-Z

	ON ERROR GOTO Fail

	DIM Buffer AS STRING * 255
	DIM DTA AS STRING * 80
	DIM DirBuffer(1 TO 10) AS STRING * 13
  
'Ŀ
' speichere Eintrittspfad                                                
'
	GOSUB ActivePath: OldPath$ = ActivePath$ + CHR$(0)

'Ŀ
' setze alle Fenster auf False                                           
'
	FOR I = 1 TO MaxWindow
		IF AWindow(I).State = True THEN OldActiveWindow = I
		AWindow(I).State = False
	NEXT

'Ŀ
' setze CommonDialogBox auf True und auf StableWindow                    
'
	AWindow(1).State = True
	AWindow(1).Visible = True
	OldStableWindow = StableWindow
	StableWindow = True
	EpsDrawWindow 1

'Ŀ
' Bilde Listen                                                           
'
	GOSUB DriveList
	DriveCounter = LEN(DriveList$)

ReEntry:
	ShowDrive = 1
	Art = 2: GOSUB MakeDir: ShowFile = 1
	Art = 3: GOSUB MakeDir: ShowFolder = 1
	GOSUB ActivePath
	IF LEN(ActivePath$) > 37 THEN
		Label(5).Caption = LEFT$(ActivePath$, 14) + "..." + RIGHT$(ActivePath$, 20)
	ELSE
		Label(5).Caption = ActivePath$
	END IF
	EpsDrawLabel 5

GetDrives:
	D$ = ""
	FOR I = 1 TO 10
		IF I > DriveCounter THEN EXIT FOR
		D$ = D$ + "[-" + MID$(DriveList$, I + ShowDrive - 1, 1) + "-] "
	NEXT
	TextBox(3).Caption = D$ + CHR$(0)
	IF DriveCounter < 10 THEN
		TextBox(3).Entrys = DriveCounter
	ELSE
		TextBox(3).Entrys = 10
	END IF
	IF ShowDrive > 1 THEN Button(5).State = True ELSE Button(5).State = False
	IF DriveCounter > 10 AND ShowDrive < DriveCounter - 10 THEN Button(6).State = True ELSE Button(6).State = False
	TextBox(3).Index = 0
	EpsDrawTextBox 3
	EpsDrawButton 5
	EpsDrawButton 6

GetFolders:
	Art = 1: GOSUB MakeDir: D$ = ""
	FOR I = 1 TO 10
		C$ = "": C$ = LEFT$(DirBuffer(I), INSTR(DirBuffer(I), CHR$(0)) - 1)
		E$ = STRING$(12, CHR$(255)) + " "
		IF INSTR(C$, ".") > 0 AND LEFT$(C$, 2) <> ".." THEN
			MID$(E$, 9) = "."
			MID$(E$, 1) = LEFT$(C$, INSTR(C$, ".") - 1)
			MID$(E$, 10) = RIGHT$(C$, LEN(C$) - INSTR(C$, "."))
		ELSE
			MID$(E$, 1) = C$
		END IF
		D$ = D$ + E$
	NEXT
	TextBox(2).Caption = D$ + CHR$(0)
	IF FolderCounter < 10 THEN
		TextBox(2).Entrys = FolderCounter
	ELSE
		TextBox(2).Entrys = 10
	END IF
	IF ShowFolder > 1 THEN Button(3).State = True ELSE Button(3).State = False
	IF FolderCounter > 10 AND ShowFolder < FolderCounter - 10 THEN Button(4).State = True ELSE Button(4).State = False
	TextBox(2).Index = 0
	EpsDrawTextBox 2
	EpsDrawButton 3
	EpsDrawButton 4

GetFiles:
	Art = 0: GOSUB MakeDir: D$ = ""
	FOR I = 1 TO 10
		C$ = "": C$ = LEFT$(DirBuffer(I), INSTR(DirBuffer(I), CHR$(0)) - 1)
		E$ = STRING$(12, CHR$(255)) + " "
		IF INSTR(C$, ".") > 0 THEN
			MID$(E$, 9) = "."
			MID$(E$, 1) = LEFT$(C$, INSTR(C$, ".") - 1)
			MID$(E$, 10) = RIGHT$(C$, LEN(C$) - INSTR(C$, "."))
		ELSE
			MID$(E$, 1) = C$
		END IF
		D$ = D$ + E$
	NEXT
	TextBox(1).Caption = D$ + CHR$(0)
	IF FileCounter < 10 THEN
		TextBox(1).Entrys = FileCounter
	ELSE
		TextBox(1).Entrys = 10
	END IF
	IF ShowFile > 1 THEN Button(1).State = True ELSE Button(1).State = False
	IF FileCounter > 10 AND ShowFile < FileCounter - 10 THEN Button(2).State = True ELSE Button(2).State = False
	TextBox(1).Index = 0
	EpsDrawTextBox 1
	EpsDrawButton 1
	EpsDrawButton 2

'Ŀ
' Beginne mit der Abfrage                                                
'
	DO: EpsMainLoop
		IF PressedButton > 0 THEN
			SELECT CASE PressedButton
				CASE 1
					ShowFile = ShowFile - 10
					IF ShowFile < 1 THEN ShowFile = 1
					GOTO GetFiles
				CASE 2
					ShowFile = ShowFile + 10
					IF ShowFile > FileCounter - 9 THEN ShowFile = FileCounter - 9
					GOTO GetFiles
				CASE 3
					ShowFolder = ShowFolder - 10
					IF ShowFolder < 1 THEN ShowFolder = 1
					GOTO GetFolders
				CASE 4
					ShowFolder = ShowFolder + 10
					IF ShowFolder > FolderCounter - 9 THEN ShowFolder = FolderCounter - 9
					GOTO GetFolders
				CASE 5
					ShowDrive = ShowDrive - 10
					IF ShowDrive < 1 THEN ShowDrive = 1
					GOTO GetDrives
				CASE 6
					ShowDrive = ShowDrive + 10
					IF ShowDrive > DriveCounter - 9 THEN ShowDrive = DriveCounter - 9
					GOTO GetDrives
				CASE 7
					GOSUB ActivePath
					IF LEN(ActivePath$) > 3 THEN ActivePath$ = ActivePath$ + "\"
					D$ = TextField(1).Caption
					CommonDialogBox$ = ActivePath$ + RTRIM$(LEFT$(D$, INSTR(D$, CHR$(0)) - 1))
					EXIT DO
				CASE 8
					CommonDialogBox$ = ""
					EXIT DO
			END SELECT
		END IF
		IF PressedTextBox > 0 THEN
			SELECT CASE PressedTextBox
				CASE 1: Art = 0: GOSUB MakeDir
					IF TextBox(1).Index <= TextBox(1).Entrys THEN
						D$ = DirBuffer(TextBox(1).Index)
						D$ = LEFT$(D$, INSTR(D$, CHR$(0)) - 1)
						TextField(1).Caption = D$ + SPACE$(12 - LEN(D$)) + CHR$(0)
						EpsDrawTextField 1
					END IF
				CASE 2: Art = 1: GOSUB MakeDir
					IF TextBox(2).Index <= TextBox(2).Entrys THEN
						D$ = DirBuffer(TextBox(2).Index)
						Buffer = LEFT$(D$, INSTR(D$, CHR$(0)) - 1) + "\" + CHR$(0)
						GOSUB SetPath
						GOTO ReEntry
					END IF
				CASE 3
					IF TextBox(3).Index <= TextBox(3).Entrys THEN
						D$ = ActiveDrive$
						Buffer = MID$(DriveList$, ShowDrive + TextBox(3).Index - 1, 1)
						GOSUB SetDrive
						GOTO ReEntry
					END IF
			END SELECT
		END IF
	LOOP UNTIL INKEY$ = MainKey$
  
'Ŀ
' Stelle Eintrittspfad wieder her, schalte CDB aus und Ende              
'
	AWindow(1).State = False
	AWindow(1).Visible = False
	AWindow(OldActiveWindow).State = True
	StableWindow = OldStableWindow
	EpsDrawScreen
	Buffer = OldPath$
	GOSUB SetPath

EXIT FUNCTION
  
'Ŀ
' UP: Aktuellen Pfad ermitteln                                           
'
ActivePath:
	Reg.ax = &H1900
	Interrupt &H21, Reg, Reg
	ActiveDrive$ = CHR$(65 + (Reg.ax AND 255))
	Reg.ax = &H4700
	Reg.dx = 0
	Reg.ds = VARSEG(Buffer)
	Reg.si = VARPTR(Buffer)
	Interrupt &H21, Reg, Reg
	ActivePath$ = ActiveDrive$ + ":\" + LEFT$(Buffer, INSTR(Buffer, CHR$(0)) - 1)
RETURN

'Ŀ
' UP: Drive/Pfad setzen                                                  
'
SetDrive:
	Fail = 0: CHDIR LEFT$(Buffer, 1) + ":"
	IF Fail > 0 THEN Buffer = D$
	Reg.ax = &HE00
	Reg.dx = ASC(LEFT$(Buffer, 1)) - 65
	Interrupt &H21, Reg, Reg
SetPath:
	Reg.ax = &H3B00
	Reg.ds = VARSEG(Buffer)
	Reg.dx = VARPTR(Buffer)
	Interrupt &H21, Reg, Reg
RETURN

'Ŀ
' UP: Directory erzeugen                                                 
'
MakeDir:
	FOR I = 1 TO 10
		DirBuffer(I) = SPACE$(11)
	NEXT
	SELECT CASE Art
		CASE 2: FileCounter = 0
		CASE 3: FolderCounter = 0
	END SELECT
  
	Reg.ax = &H1A00                     '---> Adresse auf neuen DTA setzen
	Reg.ds = VARSEG(DTA)
	Reg.dx = VARPTR(DTA)
	Interrupt &H21, Reg, Reg

	Mask$ = "*.*" + CHR$(0)
  
	Reg.ds = VARSEG(Mask$)              '---> ersten Directory Eintrag holen
	Reg.dx = SADD(Mask$)
	Reg.cx = 255
	Reg.ax = &H4E00
	Interrupt &H21, Reg, Reg

	IF (Reg.Flags AND 1) = 0 THEN
		Z = 0: I = 1
		DO: Dir$ = MID$(DTA, 31, 12)
			IF LEFT$(Dir$, 2) <> "." + CHR$(0) THEN
				Attrib = ASC(MID$(DTA, 22, 1))
				SELECT CASE Art
					CASE 0
						IF SGN(Attrib AND 16) = 0 AND SGN(Attrib AND 8) = 0 THEN
							Z = Z + 1
							IF Z >= ShowFile THEN
								DirBuffer(I) = Dir$ + CHR$(0)
								I = I + 1: IF I = ShowFile + 10 THEN EXIT DO
							END IF
						END IF
					CASE 1
						IF SGN(Attrib AND 16) = 1 THEN
							Z = Z + 1
							IF Z >= ShowFolder THEN
								DirBuffer(I) = Dir$ + CHR$(0)
								I = I + 1: IF I = ShowFolder + 10 THEN EXIT DO
							END IF
						END IF
					CASE 2
						IF SGN(Attrib AND 16) = 0 AND SGN(Attrib AND 8) = 0 THEN FileCounter = FileCounter + 1
					CASE 3
						IF SGN(Attrib AND 16) = 1 THEN FolderCounter = FolderCounter + 1
				END SELECT
			END IF
			Reg.ax = &H4F00               '---> nchsten Eintrag holen
			Interrupt &H21, Reg, Reg
		LOOP UNTIL Reg.ax = 18
	END IF

RETURN

'Ŀ
' UP: Anzahl Laufwerke ermitteln                                         
'
DriveList:
	DEF SEG = 0
	FD% = PEEK(&H410) \ 64
	DEF SEG
	IF FD% = 0 THEN D$ = "A" ELSE D$ = "AB"
	FOR I% = 3 TO 26
		Reg.ax = &H4409
		Reg.bx = I%
		Interrupt &H21, Reg, Reg
		IF (Reg.Flags AND 1) THEN EXIT FOR
		D$ = D$ + CHR$(64 + Reg.bx)
	NEXT
	DriveList$ = D$
RETURN

END FUNCTION

